#/bin/sh

Usage="Usage: $0 <process name> <SIGNAL>
result)
	http://xxx.xxx.xxx.xxx/vmf_stat.asp
	http://xxx.xxx.xxx.xxx/nic_stat.asp
	http://xxx.xxx.xxx.xxx/FwStTx_stat.asp"

SIGNALS=("SIGHUP" "SIGINT" "SIGQUIT" "SIGILL" "SIGTRAP" "SIGABRT" "SIGBUS" "SIGFPE" "SIGKILL" "SIGUSR1"
	"SIGSEGV" "SIGUSR2" "SIGPIPE" "SIGALRM" "SIGTERM" "SIGSTKFLT" "SIGCHLD" "SIGCONT" "SIGSTOP" "SIGTSTP"
	"SIGTTIN" "SIGTTOU" "SIGURG" "SIGXCPU" "SIGXFSZ" "SIGVTALRM" "SIGPROF" "SIGWINCH" "SIGIO" "SIGPWR"
	"SIGSYS" "" "" "SIGRTMIN" "SIGRTMIN+1" "SIGRTMIN+2" "SIGRTMIN+3" "SIGRTMIN+4" "SIGRTMIN+5" "SIGRTMIN+6"
	"SIGRTMIN+7" "SIGRTMIN+8" "SIGRTMIN+9" "SIGRTMIN+10" "SIGRTMIN+11" "SIGRTMIN+12" "SIGRTMIN+13" "SIGRTMIN+14" "SIGRTMIN+15" "SIGRTMAX-14"
	"SIGRTMAX-13" "SIGRTMAX-12" "SIGRTMAX-11" "SIGRTMAX-10" "SIGRTMAX-9" "SIGRTMAX-8" "SIGRTMAX-7" "SIGRTMAX-6" "SIGRTMAX-5" "SIGRTMAX-4"
	"SIGRTMAX-3" "SIGRTMAX-2" "SIGRTMAX-1" "SIGRTMAX" )

[ $# -eq 0 ] && { echo "${Usage}"; exit 1; }

PROC_NAME="$1"
SIGNAL_IN="$2"

function strcmp ()
{
    [ "$1" = "$2" ] && return 0

    [ "${1}" '<' "${2}" ] > /dev/null && return -1

    return 1
}
function strncmp ()
{
    if [ -z "${3}" -o "${3}" -le "0" ]; then
       return 0
    fi
   
    if [ ${3} -ge ${#1} -a ${3} -ge ${#2} ]; then
       strcmp "$1" "$2"
       return $?
    else
       s1=${1:0:$3}
       s2=${2:0:$3}
       strcmp $s1 $s2
       return $?
    fi
}

if [[ ${#PROC_NAME} -lt 3 ]]; then
	echo "Process name is to short!"
	exit 1;
fi

for (( i = 0; i < 64; i++ )); 
do
	if [[ "$SIGNAL_IN" = "" ]]; then
		pids=$(/bin/ps axu | grep "[${PROC_NAME:0:1}]${PROC_NAME:1}" | awk '{print $2}')
		strncmp "${PROC_NAME}" "FwStTx" 3
		echo $RETVAL
		if [[ $RETVAL -eq 0 ]]; then
			if [[ -e /web/FwStTx_stat.asp ]]; then
				rm /web/FwStTx_stat.asp
			fi
		fi
		if [[ "$pids" != "" ]]; then
			echo ${pids} | xargs kill "-SIGUSR1"
			RETVAL=$?
			if [[ $RETVAL -eq 0 ]]; then
				echo "[  OK  ]"
			else
				echo "[FAILED]"
			fi
			break
		else
			echo "The process \"${PROC_NAME}\" isn't running"
			echo "[FAILED]"; exit 1;
		fi
	fi
	if [[ $SIGNAL_IN = ${SIGNALS[$[$dow+$i]]} ]]; then
		#echo "ProcName:${PROC_NAME}, input signal: ${SIGNAL_IN} == ${SIGNALS[$[$dow+$i]]}"
		pids=$(/bin/ps axu | grep "[${PROC_NAME:0:1}]${PROC_NAME:1}" | awk '{print $2}')
		strncmp "${PROC_NAME}" "FwStTx" 3
		echo $RETVAL
		if [[ $RETVAL -eq 0 ]]; then
			if [[ -e /web/FwStTx_stat.asp ]]; then
				rm /web/FwStTx_stat.asp
			fi
		fi
		if [[ "$pids" != "" ]]; then
			echo ${pids} | xargs kill "-${SIGNAL_IN}"
			RETVAL=$?
			if [[ $RETVAL -eq 0 ]]; then
				echo "[  OK  ]"
			else
				echo "[FAILED]"
			fi
			break
		else
			echo "The process \"${PROC_NAME}\" isn't running"
			echo "[FAILED]"; exit 1;
		fi
		break
	elif [[ i -ge 63 ]]; then
		echo "Invalid signal: ${SIGNAL_IN}"
		kill -l; exit 1;
	fi
done

sleep 1

echo ""
exit $RETVAL